#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "omp.h"

#define NUM_POINTS 1000000
#define RADIUS 1.0

int main( void )
{
    long int i, count;
    double x, y;
    double pi;

    count = 0;
    #pragma omp parallel reduction(+:count) private(x,y)
    {
        #pragma omp for
        for ( i = 0; i < NUM_POINTS; i++ )
        {
            #pragma omp critical
            {
                x = drand48();
                y = drand48();
            }

            if ( sqrt(x*x+y*y) <= RADIUS )
                count += 1;
        }
    }

    pi = 4 * (double)count/NUM_POINTS;

    printf("Pi: %.15e\n", pi);

    return 0;
}
